LCTT 2014 ： LCTT 成立一年总结
============================

### 缘起 ###

一年前，我因为开发 Linux 中国的微信公众号，想着在公众号里面提供 Linux 的 man 手册应该是个不错的主意，因此在网上遍寻中文 man 手册。虽然我之前也寻找过中文的 man 手册，知道颇多不全和错漏，但是这次仔细搜寻之下，却发现还远较我预计的还差。

无奈之下，只能先使用了英文版本作为 man 的内容，并因此萌发了组织一个翻译 man 手册的活动或组织的想法。说干就干，当时我就在 Linux 中国的 QQ 群里面发起了倡议，还真得到了大家响应。

于是，2013 年 9 月 10日，草草而就的 LCTT 就成立了，很快就创建了一个 QQ 群作为交流，并确定了名称为“Linux.CN Translate Team”，简称 LCTT。考虑到需要多人协作，几乎没有多想，就决定了采用 GITHUB 作为翻译平台——虽然现在看起来，GITHUB 作为主要工作平台，有利也有弊，但是，总体来说还是不错的。LCTT 就这样启动了。

### 发展 ###

次日，我们就组织起来了翻译，并初步拟定了翻译流程、分工之类的内容。

LCTT 草创，各种方面都没有经验，也出现过一些失误。比如说，开始时对于 GITHUB 以及 GIT，大部分人，包括我，都不是很熟悉，因此并未采用 Pull-Request 模式，而是共同控制的方式，也由于一些协调和经验的原因，出现过版本错误和回滚，甚至回滚得更乱。还有，初期还要求 LINUX 中国网站 的注册身份，但是后来发现这完全不必要。

本来成立 LCTT 的目标是为了 man 手册的翻译，但是经过研究，我发现翻译 man 手册还有一些困难：

1. man 手册是二进制的 groff 格式，因此生成和解析需要一些额外的过程，甚至需要一些特定的环境；
2. man 手册对翻译的能力要求较高，并且应该对 man 手册所对应的命令有足够的了解，才能翻译得当，因为一字之差就可能导致很多误解。

所以，当时商量决定，先期启动普通的 Linux 方面、开源方面的文章翻译，以此来摸索翻译流程和锻炼协作，并作为翻译 man 手册的人员筛选环节。

我安排 Linux 中国站长，原本经常独自翻译发表来自国外文章的 DeadFire 来做选题。他负责将选题从英文的页面，转换成 Markdown 格式。我又找了朋友 jasminepeng 和 carolinewuyan 帮忙做校对，我自己则主要承担发布的工作。

初期，很快就涌现出了一些积极参与的人员，如 tinyeyeser、vito-L、boredivanivan等等，不一一列举了，他们不但积极参与翻译，而且还帮助撰写了第一批的翻译组 Wiki 文档，对引导新人起到了很大作用。

伴随着 LCTT 的逐步运作，一个月之后，我和大家感觉时间比较成熟了，就启动了 man 翻译计划。

### man 翻译计划的夭折 ###

_写下这个标题时，我也颇感觉惭愧的，这也算是我正视这个结果吧。不管怎么说，现在还是深夜，未过零点，我终究是在 LCTT 一周年之前正视了失败。_

其实，前面提到过，我检索过各种可以找到的中文 man 翻译项目的结果，但种种结果让人无法满意，因此我觉得，我应该能吸取其中的教训，为 Linux、为开源做点实事出来。

我总结的之前的 man 翻译项目失败的原因大概如下：

1. 缺乏足够的驱动力，翻译者无论从利益还是荣誉，都得不到鼓励，因此往往难以为继。
2. 由于依赖个人热情，没有形成流动机制，因此，当某个人热情耗尽之后，就没有人继续接手维护。
3. 翻译流程简单，没有形成初译、校对、发布等流程，无法保证质量，也没有保持同步更新的流程。

因此，我觉得，通过建立一个翻译的公益组织（即 LCTT）、建立翻译流程、翻译后保留翻译和校对等人员的署名，可以解决一些以上的问题。

但是，其实我还忽视了一点，翻译 man 手册，其实无论是环境还是流程，比较复杂，因此限制了参与者。参与门槛高，导致发展不能持续。

因此，实际上，man 翻译项目，在大概运作了一个月之后，就逐渐停滞下来了，虽然后期，willqian 独立完成了很多篇，但是总体来说，man 翻译项目算是失败了。

### 总结这一年 ###

抛开 man 翻译项目的失败不说，其实，LCTT 还是成果累累。

这一年，我们完成了 5820 次提交，发起了 1482 个 PR，翻译了 805 篇文章。

这一年，我们有了 98 个贡献者，得到了 162 个 fork。

我使用了一个工具，根据这一年来我们 LCTT 翻译项目的 git 日志，生成了一段[视频](http://img.linux.net.cn/static/video/lctt2014.mp4)。看着视频中如辛勤的工蜂一样忙忙碌碌的志愿者们；看着如穿花蝴蝶一样，承担了更多工作量的选题、校对们；看着归档时如同施展魔法一样，瞬间变出了一朵朵花，我感觉我们这一年是有收获的一年！

请大家观赏我们这一年： http://img.linux.net.cn/static/video/lctt2014.mp4 （213M，720p）

这是我用 kdenlive 合成配音的。虽然我的乐感很差，只能选择一首自己觉得还算配的音乐；虽然我根本不会用 kdenlive，连配音淡出都琢磨半天；虽然我编译用于生成这个视频的 gource 都花费了几个小时来解决问题；但是，看到这份视频，我为我们 LCTT 这一年来的工作感到骄傲。

### 感谢你们 ###

虽然很俗套，但是此刻，已经是 2014 年 9 月 10 日凌晨00:50了，我心情很激动，真心感谢所有的参与者、贡献者。几乎每个 LCTT 的成员我都知道，也有几个我特别熟悉；LCTT 的成员有新来的，也有逐渐淡出的，但是不论是那种，我都记得你们。

名单太长，我就不一一列举了： https://github.com/LCTT/TranslateProject/graphs/contributors 

### 接下来 ###

我会说，man 计划我不会放弃么？

是的，man 计划是 LCTT 之所以发起的原因，也是 LCTT 能够持久发展的基础，而 man 翻译也是真正对国内的 Linux 、开源发展有实在意义的事情，所以，我不会放弃。

我会投入精力开发一个翻译平台，用于 man 项目的翻译、校对和发布，将复杂的翻译环境配置和使用方法隐藏在后面；并增加可视化的图表和进度显示，明了的体现翻译工作进展；对接 man7.org 的最新更新，保持 man 内容的及时更新等等。

期待 LCTT 的下一个年度的发展吧！

----

LCTT wxy

2014 年 9 月 10 日