为什么主线内核不能运行在我的手机上？
==================

对于自由软件来说，其最大的自由之一就是能够用一个更新或修改的版本来替换原始版本的程序。尽管如此，数千万使用那些手机里面装着所谓 Linux 的用户却很少能够在他们的手机上运行主线内核（mainline kernel），即使他们拥有替换内核代码的专业技能。可悲的是，我们必须承认目前仍然没有可以运行主线内核的主流手机。在由 Rob Herring 主持的2015届内核峰会（Kernel Summit）上，与会人员共同探讨了这个问题，并进一步谈论了他们应该怎么做才能解决这个问题。

当主持人提问的时候，在座的大多数开发人员都表示他们更乐意在他们的手机上面运行主线内核，然而也有少数人持相反的看法。在 Project Ara 的支持下，Rob 在这个问题上已经研究了近一年半的时间（参见：https://lwn.net/Articles/648400/ ）。但是最新的研究成果并不理想。

Rob 表示，通常手机上运行了太多的过期(out-of-tree)代码；主线内核只是缺少能使手机正常运行所必须的驱动。每台常规的手机都在运行着100万行到300万行的过期(out-of-tree)代码。几乎所有的这些手机的内核版本都不超过3.10，有一些甚至更加古老。造成这种情况的原因有很多，但是有一点是很清楚的，在手机的世界里，一切都变化的太快以至于无法跟上内核社区的步伐。如果真是那样，他问到，我们还担心什么呢？

Tim Bird 指出，第一台 Android 手机 Nexus 1 从来没有运行过任何一个主线内核，并且以后也不会。它打破了开源的承诺，也使得用户不可能做到将一个新的内核放到手机中。从这一点上来说，没有任何一款手机支持这种能力。Peter Zijlstra 想知道从一台手机到另一台手机到底复制了多少能够工作的过期代码；Rob表示，迄今为止，他已经见到了三个独立开发的热插拔 [Governors][1]。

Dirk Hohndel 提出了很少有人注意到的建议。他说，对于世界上的数以亿计的手机，大约只有他们27个人关心他们的手机是否运行着主线内核。剩下的用户仅仅只是想让他们的手机正常工作。或许那些关注手机是否在运行主线内核的开发者正在努力去解决这个令人不解的问题。

Chris Mason 说，那些手机厂商当前正面临着相同类型的问题，而这些问题也是那些 Linux 发行版过去所面临过的问题。他们疲于应付大量的无效且重复和能被复用的工作。一旦这些发行版决定将他们的工作配合主线内核而不是使用自己维护的内核，那么问题将会变得好解决的多。解决问题的关键就是去帮助手机制造商们认识到他们可以通过同样的方式获得便利，形成这种认识的关键并不是通过来自用户的压力。这样一来，问题就可以解决了。

Grant Likely 提出了对于安全问题的担忧，这种担忧来自于那些不能升级他们的手机系统的 android 设备。他说，我们需要的是一个真正专为手机设立的发行版。但是，只要手机厂商仍然掌控着手机中的应用软件，那么手机的同步更新将无法实现。我们接下来将面临一个很大的安全难题。Peter 补充说，随着 [Stagefright 漏洞][2]的出现，难题已经出现在我们面前了。

Ted Ts'o 说，运行主线内核并不是他的主要关注点。他很乐于见到这个假期中所售卖的手机能够运行3.18或者4.1的内核，而不是继续停留在3.10。他认为这是一个更可能被解决的问题。Steve Rostedt 认为，按照 Ted Ts'o 所说的那样去做并不能解决手机的安全问题，但是，Ted 认为使用一个更新一些的内核至少可以让漏洞修复变得更加容易。Grant 对此回应说，接下来的一年里，这一切都将再次发生。过渡到更新的内核也是一个渐进式的对系统的完善。Kees Cook 补充说，我们无法从修复旧版本的内核漏洞的过程中得到太多的益处，真正的问题是我们没有对 bug 的应对措施（他会在今天的另外一个对话中讲到这个话题）。

Rob 说，任何一种解决方案都需要得到当前市场上的手机供应商的支持。否则，由于厂商对安装到他们生产的手机上的操作系统的封锁，运行主线内核的策略将会陷入麻烦。Paolo Bonzini 提问说是否可以因为那些没有修复的安全漏洞而控告手机厂商，尤其当手机仍然处于保修期内。Grant 认为对于手机的可更新能力（upgradeability）的保证必须来源于市场需求，否则是无法实现的。而促使它实现的原因可能会是一个严重的安全问题，然后用户开始对手机的可更新能力提出要求。同时，内核开发人员必须不断朝着这个方向努力。Rob 表示，除了到目前为止指出的所有优点之外，运行主线内核也能帮助开发者对安卓设备上的新特性进行测试和验证。

Josh Triplett 提问说，如果手机厂商提出对主线内核提供支持的想法，那么内核社区又将采取什么措施呢？那样将会针对手机各方面的特性要求对内核进行大量的测试和验证；[Android 的兼容性测试套件][3]中出现的失败将不得不被再次回归到内核。Rob 提议这个问题可以在明年讨论，即先将最基本的功能做好。但是，Josh 强调说，如果这个需求出现了，我们就应该能够给出一个好的答案。

Tim 认为，当前，我们和厂商之间存在很大的脱节。厂商根本不会主动报告或者贡献任何反馈给社区。他们之间完全脱节了，这样的话永远不会有进步。Josh 表示，当厂商们开始报告他们正在使用的旧内核的相关 bug 时，双方之间的接受度将变得更加友好。Arnd Bergmann 认为，我们需要的是得到一个大芯片厂商对使用主线内核的认可，并且将该厂商的硬件提升到能够支持主线内核的运行的这样一个水平，而这样将会在其他方面增加负担。但是，他补充说，实现这个目标要求存在一个跟随硬件一起分发的自由 GPU 驱动程序——然而这种程序当前并不存在。

Rob 给存在问题的领域列了一个清单，但是现在已经没有太多的时间去讨论其中的细节了。WiFi 驱动仍然是一个问题，尤其是当这个新特性被添加到 Android 设备上的时候。Johannes Berg 对新特性仍然存在问题表示赞同；Android 的开发人员甚至在这些新特性被应用到 Android 设备上之前都不会去谈论它们是否存在问题。然而，对这些特性中的大多数的技术支持最终都会落实在主线内核中。

随着会议逐渐接近尾声，Ben Herrenschmidt 再次重申：实现在 Android 手机上运行主线内核的关键还是在于让厂商认识到使用主线内核是它们获得最大利润的最好选择。从长远看，使用主线内核能节省大量的工作。Mark Brown 认为，以前，当搭载在 Android 设备上的内核版本以更稳定的方式向前推进的时候，上游工作的好处对运营商来说更加明显。以现在的情况来看，手机上的内核版本似乎停留在了3.10，那种压力是不一样的。

这次谈话以开发者决定进一步改善当前的状况而结束，但是却并没有对如何改善提出一个明确的计划。
    
---------------------------------------------------------------------------------		

via: https://lwn.net/Articles/662147/		
	
作者：[Jonathan Corbet][a]
译者：[kylepeng93](https://github.com/kylepeng93)
校对：[wxy](https://github.com/wxy)		
		
本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](http://linux.cn/) 荣誉推出		
		
[a]:https://lwn.net/Articles/KernelSummit2015/
[1]:http://androidmodguide.blogspot.com/p/blog-page.html
[2]:https://lwn.net/Articles/652728/
[3]:https://source.android.com/compatibility/cts/index.html
