如何加入一个技术社区
============================================================

> 参照以下几步可以让你很容易地融入社区

 ![How to join a technical community](https://opensource.com/sites/default/files/styles/image-full-size/public/images/business/BIZ_DebucketizeOrgChart_A.png?itok=oBdRm8vc "How to join a technical community") 
 
*图片提供： opensource.com*

加入一个新的社区在很多情况下可能是一个艰巨的任务。当加入一个新的技术社区时，焦虑感可能特别强烈，尤其是一些社区对新成员的严厉甚至讥讽都是有名的。

虽然有可能陷入一个不公正的地方，但是我认为你会发现大多数技术社区是相当合理的，并且以下几个简单的步骤可以缓解从非成员到成员的过渡。

### 冷暖自知

在你开始实际加入社区前，首先你要确保该社区适合你，同时你也是合适该社区。

这听起来很简单，但每个社区都有不同的文化、态度、理念和公认的规范。如果你对某个话题还了解甚少，那么面向行业专业人士的社区可能就不是一个理想的起点。同样，如果你是一个资深专家，希望寻找深入并且极其复杂问题的答案，那么初学者的社区肯定也不太合适。无论哪种方式，两边的不匹配几乎肯定会导致双方的失望。同样，一些社区是非常正规并且面向商业的，而另一些社区将非常宽松和悠闲，也有许多社区的氛围处于二者之间。选择适合你自己的社区，或至少不是让你厌恶的社区，这将有助于确保你的长期参与，可以使你顺利的迈出这一步。

### 潜龙勿用

最初以只读模式围观参与社区是一个好方法。但这并不意味着你不应该立即创建一个帐户或加入，只是你可以通过围观社区得到一个空间感（无论是虚拟的或物理的）。潜伏一段时间有助于你适应社区的规则和文化，以此确定你是否认为这是一个很适合你的平台。

### 毛遂自荐

根据社区的不同，自我介绍的细节将有很大的不同。同样，确保这样做的方式容易被社区接受。

有些社区可能有一个专门的介绍板块，而在另一些社区，它可能是填写你的个人资料等有意义和相关的信息。如果社区是邮件列表或 IRC 频道，在你的首次发问中包含简要介绍可能更有意义。这可以让社区了解你是谁，为什么你想成为社区的一部分，并让他们知道一点关于你自己和你的技术水平的信息。

### 相敬如宾

虽然社区与社区的接受方式有很大的不同，但你应该永远保持尊重。避免争吵和人身攻击，并始终致力于建设。记住，你在互联网上发布的东西，它就会一直在那里，不尽不灭，并为大家所看到。

### 非礼勿言

#### 提问

记住，精心设计的问题可以更快地得到更好的答案，正如我在十月专栏 [The Queue][2] 中指出的那样。

#### 回答

一旦遇见了自己很了解的关于基础或非常容易回答的提问时，“尊重”的理念也同样适用，就像提问时一样。一个冗长的并充满优越感的技术上正确的答案，并不是向一个新的社区介绍自己的正确方式。

#### 闲话

即使在技术社区，也并不是所有的讨论都是关于某个问题或答案。在这种情况下，以尊重和周到的、不带有侮辱和人身攻击的方式，提出不同的意见或挑战他人的观点才是健康正确的做法。

### 不亦说乎

长期参加社区最重要的事情是在那里可以满足自己。参与一个充满活力的社区是一个学习、成长、挑战和提升自我的好机会。很多情况下，这并不容易，但它是值得的。

--------------------------------------------------------------------------------

作者简介：

Jeremy Garcia - Jeremy Garcia 是 LinuxQuestions.org 的创始人，同时也是一个热情和注重实际的开源拥护者。个人推特: @linuxquestions

--------------------------------------------------------------------------------

via: https://opensource.com/article/17/1/how-join-technical-community

作者：[Jeremy Garcia][a]
译者：[livc](https://github.com/livc)
校对：[Bestony](https://github.com/Bestony), [wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/jeremy-garcia
[1]:https://opensource.com/article/17/1/how-join-technical-community?rate=SfjMzwYInmhZiq6Yva3D87kngE-ocLOVraCD0wWbBss
[2]:https://opensource.com/life/16/10/how-ask-technical-questions
[3]:https://opensource.com/user/86816/feed
[4]:https://opensource.com/article/17/1/how-join-technical-community#comments
[5]:https://opensource.com/users/jeremy-garcia
