T-UI Launcher：将你的 Android 设备变成 Linux 命令行界面
============================================================

不管你是一位命令行大师，还是只是不想让你的朋友和家人使用你的 Android 设备，那就看下 T-UI Launcher 这个程序。Unix/Linux 用户一定会喜欢这个。

T-UI Launcher 是一个免费的轻量级 Android 程序，具有类似 Linux 的命令行界面，它可将你的普通 Android 设备变成一个完整的命令行界面。对于喜欢使用基于文本的界面的人来说，这是一个简单、快速、智能的启动器。

#### T-UI Launcher 功能

下面是一些重要的功能：

*   第一次启动后展示快速使用指南。
*   快速且可完全定制。
*   提供自动补全菜单及快速、强大的别名系统。
*   此外，提供预测建议，并提供有用的搜索功能。

它是免费的，你可以从 Google Play 商店[下载并安装它][1]，接着在 Android 设备中运行。

安装完成后，第一次启动时你会看到一个快速指南。阅读完成之后，你可以如下面那样使用简单的命令开始使用了。

[![T-UI Commandline Help Guide](https://www.tecmint.com/wp-content/uploads/2017/05/T-UI-Commandline-Help.jpg)][2] 

*T-UI 命令行帮助指南*

要启动一个 app，只要输入几个字母，自动补全功能会在屏幕中展示可用的 app。接着点击你想打开的程序。

```
$ Telegram   ### 启动 telegram
$ WhatsApp   ### 启动 whatsapp
$ Chrome     ### 启动 chrome
```

[![T-UI Commandline Usage](https://www.tecmint.com/wp-content/uploads/2017/05/T-UI-Commandline-Usage.jpg)][3] 

*T-UI 命令行使用*

要浏览你的 Android 设备状态（电池电量、wifi、移动数据），输入：

```
$ status
```

[![Android Phone Status](https://www.tecmint.com/wp-content/uploads/2017/05/T-UI-Commandline-Status.jpg)][4] 

*Android 电话状态*

其它的有用命令。

```
$ uninstall telegram				### 卸载 telegram 
$ search [google, playstore, youtube, files]	### 搜索在线应用或本地文件
$ wifi						### 打开或关闭 WIFI
$ cp Downloads/* Music				### 从 Download 文件夹复制所有文件到 Music 文件夹
$ mv Downloads/* Music				### 从 Download 文件夹移动所有文件到 Music 文件夹 
```

就是这样了！在本篇中，我们展示了一个带有类似 Linux CLI（命令界面）的简单而有用的 Android 程序，它可以将你的常规 Android 设备变成一个完整的命令行界面。尝试一下并在下面的评论栏分享你的想法。

--------------------------------------------------------------------------------

作者简介：

Aaron Kili 是 Linux 和 F.O.S.S 爱好者，将来的 Linux 系统管理员和网络开发人员，目前是 TecMint 的内容创作者，他喜欢用电脑工作，并坚信分享知识。

------------------

via: https://www.tecmint.com/t-ui-launcher-turns-android-device-into-linux-cli/

作者：[Aaron Kili][a]
译者：[geekpi](https://github.com/geekpi)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://www.tecmint.com/author/aaronkili/
[1]:https://play.google.com/store/apps/details?id=ohi.andre.consolelauncher
[2]:https://www.tecmint.com/wp-content/uploads/2017/05/T-UI-Commandline-Help.jpg
[3]:https://www.tecmint.com/wp-content/uploads/2017/05/T-UI-Commandline-Usage.jpg
[4]:https://www.tecmint.com/wp-content/uploads/2017/05/T-UI-Commandline-Status.jpg
[5]:https://www.tecmint.com/author/aaronkili/
[6]:https://www.tecmint.com/10-useful-free-linux-ebooks-for-newbies-and-administrators/
[7]:https://www.tecmint.com/free-linux-shell-scripting-books/
