你或许不知道的实用 GNOME Shell 快捷键
=======================================

![](https://www.maketecheasier.com/assets/uploads/2017/10/gnome-shortcuts-00-featured.jpg)

由于 Ubuntu 在 17.10 发行版本中转移到了 GNOME Shell，许多用户可能对那些实用的快捷键以及创建自己的快捷键感兴趣。这篇文章就是介绍这两方面的。

### 已有的便捷的 GNOME Shell 快捷键

如果你希望 GNOME 有成百上千种快捷键，你会失望地发现，情况并非如此。快捷键的列表不会太长，而且并不是全部都对你有用，但仍然会有许多快捷键可以用得上的。

![gnome-shortcuts-01-settings][1]

可以通过菜单“设置 -> 设备 -> 键盘”访问快捷方式列表。以下是一些不太流行但实用的快捷方式。

* `Ctrl` + `Alt` + `T` - 这是一个用来启动终端的快捷键组合，你可以在 GNOME 的任何地方使用它。

我个人经常使用的两个快捷键是：

* `Alt` + `F4` - 关闭最顶层端口
* `Alt` + `F8` - 调整窗口大小

大多数人都知道如何用 `Alt` + `Tab` 在打开的应用程序窗口之间，但是你可能不知道可以使用 `Alt` + `Shift` + `Tab` 在应用程序窗口之间进行反方向切换。

在切换窗口界面时，另一个有用的组合键是 `Alt` + `~` （`tab` 键上面的一个键）。

要是你想显示活动概览，你可以用快捷键 `Alt` + `F1`。

有很多跟工作台有关的快捷键。如果你像我那样不经常使用多个工作台的话，这些快捷键对来说是没用的。尽管如此，以下几个快捷键还是值得留意的：
  
* `Super` + `PageUp` （或者 `PageDown` ）移动到上方或下方的工作台
* `Ctrl` + `Alt` + `Left` （或 `Right` ）移动到左侧或右侧的工作台

如果在这些快捷键中加上 `Shift` ，例如 `Shift` + `Ctrl` + `Alt` + `Left`，则可以把当前窗口移动到其他工作区。

另一个我最喜欢是辅助功能中的调整文字大小的快捷键。你可以用 `Ctrl` + `+` （或 `Ctrl` + `-` ）快速缩放字体大小。在某些情况下，这个快捷键可能默认是禁用的，所以在尝试之前请先检查一下。 

上述是一些鲜为人知但是十分实用的键盘快捷键。如果你想知道更多实用的快捷键，可以查看[官方 GNOME Shell 快捷键列表][2]。

### 如何创建自己的 GNOME Shell 快捷键

如果默认的快捷键不符合您的喜好，可以更改它们或创建新的快捷键。你同样可以通过菜单“设置 -> 设备 -> 键盘“完成这些操作。当你选择想更改的快捷键条目时，下面的对话框就会弹出。

![gnome-shortcuts-02-change-shortcut][3]

输入你想要的键盘快捷键组合。

![gnome-shortcuts-03-set-shortcut][4]

如果这个快捷键已经被使用，你会得到一个消息。如果没有，只需点击设置，就完成了。

如果要添加新快捷键而不是更改现有快捷键，请向下滚动，直到看到 “+” 标志，单击它，在出现的对话框中输入新键盘快捷键的名称和快捷键组合。

![gnome-shortcuts-04-add-custom-shortcut][5]

GNOME 默认情况下并没有提供大量的 shell 快捷键，上面列出的是一些比较实用的快捷键。如果这些快捷键对你来说不够，你可以随时创建自己的快捷键。

--------------------------------------------------------------------------------

via: https://www.maketecheasier.com/gnome-shell-keyboard-shortcuts/

作者：[Ada Ivanova][a]
译者：[imquanquan](https://github.com/imquanquan)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://www.maketecheasier.com/author/adaivanoff/
[1]:https://www.maketecheasier.com/assets/uploads/2017/10/gnome-shortcuts-01-settings.jpg (gnome-shortcuts-01-settings)
[2]:https://wiki.gnome.org/Projects/GnomeShell/CheatSheet
[3]:https://www.maketecheasier.com/assets/uploads/2017/10/gnome-shortcuts-02-change-shortcut.png (gnome-shortcuts-02-change-shortcut)
[4]:https://www.maketecheasier.com/assets/uploads/2017/10/gnome-shortcuts-03-set-shortcut.png (gnome-shortcuts-03-set-shortcut)
[5]:https://www.maketecheasier.com/assets/uploads/2017/10/gnome-shortcuts-04-add-custom-shortcut.png (gnome-shortcuts-04-add-custom-shortcut)
