Top 20 GNOME Extensions You Should Be Using Right Now
============================================================

 _Brief: You can enhance the capacity of your GNOME desktop with extensions. Here, we list the best GNOME extensions to save you the trouble of finding them on your own._ 

[GNOME extensions][9] are a major part of the [GNOME][10] experience. These extensions add a lot of value to the ecosystem whether it is to mold the Gnome Desktop Environment (DE) to your workflow, to add more functionality than there is by default, or just simply to freshen up the experience.

With default [Ubuntu 17.10][11] switching from [Unity to Gnome][12], now is the time to familiarize yourself with the various extensions that the GNOME community has to offer. We already showed you[ how to enable and manage GNOME extensions][13]. But finding good extensions could be a daunting task. That’s why I created this list of best GNOME extensions to save you some trouble.

### Best GNOME Extensions

![Best GNOME Extensions for Ubuntu](https://itsfoss.com/wp-content/uploads/2017/12/Best-GNOME-Extensions-800x450.jpg)

The list is in alphabetical order but there is no ranking involved here. Extension at number 1 position is not better than the rest of the extensions.

### 1\. Appfolders Management extensions

One of the major features that I think GNOME is missing is the ability to organize the default application grid. This is something included by default in [KDE][14]‘s Application Dashboard, in [Elementary OS][15]‘s Slingshot Launcher, and even in macOS, yet as of [GNOME 3.26][16] it isn’t something that comes baked in. Appfolders Management extension changes that.

This extension gives the user an easy way to organize their applications into various folders with a simple right click > add to folder. Creating folders and adding applications to them is not only simple through this extension, but it feels so natively implemented that you will wonder why this isn’t built into the default GNOME experience.

![](https://itsfoss.com/wp-content/uploads/2017/11/folders-300x225.jpg)

[Appfolders Management extension][17]

### 2\. Apt Update Indicator

For distributions that utilize [Apt as their package manager][18], such as Ubuntu or Debian, the Apt Update Indicator extension allows for a more streamlined update experience in GNOME.

The extension settles into your top bar and notifies the user of updates waiting on their system. It also displays recently added repos, residual config files, files that are auto removable, and allows the user to manually check for updates all in one basic drop-down menu.

It is a simple extension that adds an immense amount of functionality to any system. 

![](https://itsfoss.com/wp-content/uploads/2017/11/Apt-Update-300x185.jpg)

[Apt Update Indicator][19]

### 3\. Auto Move Windows

If, like me, you utilize multiple virtual desktops than this extension will make your workflow much easier. Auto Move Windows allows you to set your applications to automatically open on a virtual desktop of your choosing. It is as simple as adding an application to the list and selecting the desktop you would like that application to open on.

From then on every time you open that application it will open on that desktop. This makes all the difference when as soon as you login to your computer all you have to do is open the application and it immediately opens to where you want it to go without manually having to move it around every time before you can get to work.

![](https://itsfoss.com/wp-content/uploads/2017/11/auto-move-300x225.jpg)

[Auto Move Windows][20]

### 4\. Caffeine 

Caffeine allows the user to keep their computer screen from auto-suspending at the flip of a switch. The coffee mug shaped extension icon embeds itself into the right side of your top bar and with a click shows that your computer is “caffeinated” with a subtle addition of steam to the mug and a notification.

The same is true to turn off Caffeine, enabling auto suspend and/or screensave again. It’s incredibly simple to use and works just as you would expect.

Caffeine Disabled:  
![](https://itsfoss.com/wp-content/uploads/2017/11/caffeine-enabled-300x78.jpg)

Caffeine Enabled:
![](https://itsfoss.com/wp-content/uploads/2017/11/caffeine-disabled-300x75.jpg)

[Caffeine][21]

### 5\. CPU Power Management [Only for Intel CPUs]

This is an extension that, at first, I didn’t think would be very useful, but after some time using it I have found that functionality like this should be backed into all computers by default. At least all laptops. CPU Power Management allows you to chose how much of your computer’s resources are being used at any given time.

Its simple drop-down menu allows the user to change between various preset or user made profiles that control at what frequency your CPU is to run. For example, you can set your CPU to the “Quiet” present which tells your computer to only us a maximum of 30% of its resources in this case.

On the other hand, you can set it to the “High Performance” preset to allow your computer to run at full potential. This comes in handy if you have loud fans and want to minimize the amount of noise they make or if you just need to save some battery life.

One thing to note is that  _this only works on computers with an Intel CPU_ , so keep that in mind.

![](https://itsfoss.com/wp-content/uploads/2017/11/CPU-300x194.jpg)

[CPU Power Management][22]

### 6\. Clipboard Indicator 

Clipboard Indicator is a clean and simple clipboard management tool. The extension sits in the top bar and caches your recent clipboard history (things you copy and paste). It will continue to save this information until the user clears the extension’s history.

If you know that you are about to work with documentation that you don’t want to be saved in this way, like Credit Card numbers or any of your personal information, Clipboard Indicator offers a private mode that the user can toggle on and off for such cases.

![](https://itsfoss.com/wp-content/uploads/2017/11/clipboard-300x200.jpg)

[Clipboard Indicator][23]

### 7\. Extensions

The Extensions extension allows the user to enable/disable other extensions and to access their settings in one singular extension. Extensions either sit next to your other icons and extensions in the panel or in the user drop-down menu.

Redundancies aside, Extensions is a great way to gain easy access to all your extensions without the need to open up the GNOME Tweak Tool to do so. 

![](https://itsfoss.com/wp-content/uploads/2017/11/extensions-300x185.jpg)

[Extensions][24]

### 8\. Frippery Move Clock

For those of us who are used to having the clock to the right of the Panel in Unity, this extension does the trick. Frippery Move Clock moves the clock from the middle of the top panel to the right side. It takes the calendar and notification window with it but does not migrate the notifications themselves. We have another application later in this list, Panel OSD, that can add bring your notifications over to the right as well.

Before Frippery: 
![](https://itsfoss.com/wp-content/uploads/2017/11/before-move-clock-300x19.jpg)

After Frippery:
![](https://itsfoss.com/wp-content/uploads/2017/11/after-move-clock-300x19.jpg)

[Frippery Move Clock][25]

### 9\. Gno-Menu

Gno-Menu brings a more traditional menu to the GNOME DE. Not only does it add an applications menu to the top panel but it also brings a ton of functionality and customization with it. If you are used to using the Applications Menu extension traditionally found in GNOME but don’t want the bugs and issues that Ubuntu 17.10 brought to is, Gno-Meny is an awesome alternative.

![](https://itsfoss.com/wp-content/uploads/2017/11/Gno-Menu-300x169.jpg)

[Gno-Menu][26]

### 10\. User Themes

User Themes is a must for anyone looking to customize their GNOME desktop. By default, GNOME Tweaks lets its users change the theme of the applications themselves, icons, and cursors but not the theme of the shell. User Themes fixes that by enabling us to change the theme of GNOME Shell, allowing us to get the most out of our customization experience.  Check out our [video][27] or read our article to know how to [install new themes][28].

User Themes Off:
![](https://itsfoss.com/wp-content/uploads/2017/11/user-themes-off-300x141.jpg)
User Themes On:
![](https://itsfoss.com/wp-content/uploads/2017/11/user-themes-on-300x141.jpg)

[User Themes][29]

### 11\. Hide Activities Button

Hide Activities Button does exactly what you would expect. It hides the activities button found a the leftmost corner of the top panel. This button traditionally actives the activities overview in GNOME, but plenty of people use the Super Key on the keyboard to do this same function.

Though this disables the button itself, it does not disable the hot corner. Since Ubuntu 17.10 offers the ability to shut off the hot corner int he native settings application this not a huge deal for Ubuntu users. For other distributions, there are a plethora of other ways to disable the hot corner if you so desire, which we will not cover in this particular article.

Before: ![](https://itsfoss.com/wp-content/uploads/2017/11/activies-present-300x15.jpg) After:
![](https://itsfoss.com/wp-content/uploads/2017/11/activities-removed-300x15.jpg)

#### [Hide Activities Button][30] 

### 12\. MConnect

MConnect offers a way to seamlessly integrate the [KDE Connect][31] application within the GNOME desktop. Though KDE Connect offers a way for users to connect their Android handsets with virtually any Linux DE its indicator lacks a good way to integrate more seamlessly into any other DE than [Plasma][32].

MConnect fixes that, giving the user a straightforward drop-down menu that allows them to send SMS messages, locate their phones, browse their phone’s file system, and to send files to their phone from the desktop. Though I had to do some tweaking to get MConnect to work just as I would expect it to, I couldn’t be any happier with the extension.

Do remember that you will need KDE Connect installed alongside MConnect in order to get it to work.

![](https://itsfoss.com/wp-content/uploads/2017/11/MConenct-300x174.jpg)

[MConnect][33]

### 13\. OpenWeather

OpenWeather adds an extension to the panel that gives the user weather information at a glance. It is customizable, it lets the user view weather information for whatever location they want to, and it doesn’t rely on the computers location services. OpenWeather gives the user the choice between [OpenWeatherMap][34] and [Dark Sky][35] to provide the weather information that is to be displayed.

![](https://itsfoss.com/wp-content/uploads/2017/11/OpenWeather-300x147.jpg)

[OpenWeather][36]

### 14\. Panel OSD

This is the extension I mentioned earlier which allows the user to customize the location in which their desktop notifications appear on the screen. Not only does this allow the user to move their notifications over to the right, but Panel OSD gives the user the option to put their notifications literally anywhere they want on the screen. But for us migrating from Unity to GNOME, switching the notifications from the top middle to the top right may make us feel more at home.

Before:
![](https://itsfoss.com/wp-content/uploads/2017/11/osd1-300x40.jpg)

After:
![](https://itsfoss.com/wp-content/uploads/2017/11/osd-300x36.jpg)

#### [Panel OSD][37] 

### 15\. Places Status Indicator

Places Status Indicator has been a recommended extension for as long as people have started recommending extensions. Places adds a drop-down menu to the panel that gives the user quick access to various areas of the file system, from the home directory to serves your computer has access to and anywhere in between.

The convenience and usefulness of this extension become more apparent as you use it, becoming a fundamental way you navigate your system. I couldn’t recommend it more highly enough.

![](https://itsfoss.com/wp-content/uploads/2017/11/Places-288x300.jpg)

[Places Status Indicator][38]

### 16\. Refresh Wifi Connections

One minor annoyance in GNOME is that the Wi-Fi Networks dialog box does not have a refresh button on it when you are trying to connect to a new Wi-Fi network. Instead, it makes the user wait while the system automatically refreshes the list. Refresh Wifi Connections fixes this. It simply adds that desired refresh button to the dialog box, adding functionality that really should be included out of the box.

Before: 
![](https://itsfoss.com/wp-content/uploads/2017/11/refresh-before-292x300.jpg)

After:
![](https://itsfoss.com/wp-content/uploads/2017/11/Refresh-after-280x300.jpg)

#### [Refresh Wifi Connections][39] 

### 17\. Remove Dropdown Arrows

The Remove Dropdown Arrows extension removes the arrows on the panel that signify when an icon has a drop-down menu that you can interact with. This is purely an aesthetic tweak and isn’t always necessary as some themes remove these arrows by default. But themes such as [Numix][40], which happens to be my personal favorite, don’t remove them.

Remove Dropdown Arrows brings that clean look to the GNOME Shell that removes some unneeded clutter. The only bug I have encountered is that the CPU Management extension I mentioned earlier will randomly “respawn” the drop-down arrow. To turn it back off I have to disable Remove Dropdown Arrows and then enable it again until once more it randomly reappears out of nowhere. 

Before:  
![](https://itsfoss.com/wp-content/uploads/2017/11/remove-arrows-before-300x17.jpg)

After:
![](https://itsfoss.com/wp-content/uploads/2017/11/remove-arrows-after-300x14.jpg)

[Remove Dropdown Arrows][41]

### 18\. Status Area Horizontal Spacing

This is another extension that is purely aesthetic and is only “necessary” in certain themes. Status Area Horizontal Spacing allows the user to control the amount of space between the icons in the status bar. If you think your status icons are too close or too spaced out, then this extension has you covered. Just select the padding you would like and you’re set.

Maximum Spacing: 
![](https://itsfoss.com/wp-content/uploads/2017/11/spacing-2-300x241.jpg)

Minimum Spacing:
![](https://itsfoss.com/wp-content/uploads/2017/11/spacing-300x237.jpg)

#### [Status Area Horizontal Spacing][42] 

### 19\. Steal My Focus

By default, when you open an application in GNOME is will sometimes stay behind what you have open if a different application has focus. GNOME then notifies you that the application you selected has opened and it is up to you to switch over to it. But, in my experience, this isn’t always consistent. There are certain applications that seem to jump to the front when opened while the rest rely on you to see the notifications to know they opened.

Steal My Focus changes that by removing the notification and immediately giving the user focus of the application they just opened. Because of this inconsistency, it was difficult for me to get a screenshot so you just have to trust me on this one. ;)

#### [Steal My Focus][43] 

### 20\. Workspaces to Dock 

This extension changed the way I use GNOME. Period. It allows me to be more productive and aware of my virtual desktop, making for a much better user experience. Workspaces to Dock allows the user to customize their overview workspaces by turning into an interactive dock.

You can customize its look, size, functionality, and even position. It can be used purely for aesthetics, but I think the real gold is using it to make the workspaces more fluid, functional, and consistent with the rest of the UI.

![](https://itsfoss.com/wp-content/uploads/2017/11/Workspaces-to-dock-300x169.jpg)

[Workspaces to Dock][44]

### Honorable Mentions: Dash to Dock and Dash to Panel  

Dash to Dock and Dash to Panel are not included in the official 20 extensions of this article for one main reason: Ubuntu Dock. Both extensions allow the user to make the GNOME Dash either a dock or a panel respectively and add more customization than comes by default.

The problem is that to get the full functionality of these two extensions you will need to jump through some hoops to disable Ubuntu Dock, which I won’t outline in this article. We acknowledge that not everyone will be using Ubuntu 17.10, so for those of you that aren’t this may not apply to you. That being said, bot of these extensions are great and are included among some of the most popular GNOME extensions you will find.

Currently, there is a “bug” in Dash to Dock whereby changing its setting, even with the extension disabled, the changes apply to the Ubuntu Dock as well.  I say “bug” because I actually use this myself to customize Ubuntu Dock without the need for the extensions to be activated.  This may get patched in the future, but until then consider that a free tip.

###    [Dash to Dock][45]     [Dash to Panel][46]

So there you have it, our top 20 GNOME Extensions you should try right now. Which of these extensions do you particularly like? Which do you dislike? Let us know in the comments below and don’t be afraid to say something if there is anything you think we missed.

### About Phillip Prado

Phillip Prado is an avid follower of all things tech, culture, and art. Not only is he an all-around geek, he has a BA in cultural communications and considers himself a serial hobbyist. He loves hiking, cycling, poetry, video games, and movies. But no matter what his passions are there is only one thing he loves more than Linux and FOSS: coffee. You can find him (nearly) everywhere on the web as @phillipprado.
--------------------------------------------------------------------------------

via: https://itsfoss.com/best-gnome-extensions/

作者：[ Phillip Prado][a]
译者：[译者ID](https://github.com/译者ID)
校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://itsfoss.com/author/phillip/
[1]:https://itsfoss.com/author/phillip/
[2]:https://itsfoss.com/best-gnome-extensions/#comments
[3]:https://www.facebook.com/share.php?u=https%3A%2F%2Fitsfoss.com%2Fbest-gnome-extensions%2F%3Futm_source%3Dfacebook%26utm_medium%3Dsocial%26utm_campaign%3DSocialWarfare
[4]:https://twitter.com/share?original_referer=/&text=Top+20+GNOME+Extensions+You+Should+Be+Using+Right+Now&url=https://itsfoss.com/best-gnome-extensions/%3Futm_source%3Dtwitter%26utm_medium%3Dsocial%26utm_campaign%3DSocialWarfare&via=phillipprado
[5]:https://plus.google.com/share?url=https%3A%2F%2Fitsfoss.com%2Fbest-gnome-extensions%2F%3Futm_source%3DgooglePlus%26utm_medium%3Dsocial%26utm_campaign%3DSocialWarfare
[6]:https://www.linkedin.com/cws/share?url=https%3A%2F%2Fitsfoss.com%2Fbest-gnome-extensions%2F%3Futm_source%3DlinkedIn%26utm_medium%3Dsocial%26utm_campaign%3DSocialWarfare
[7]:http://www.stumbleupon.com/submit?url=https://itsfoss.com/best-gnome-extensions/&title=Top+20+GNOME+Extensions+You+Should+Be+Using+Right+Now
[8]:https://www.reddit.com/submit?url=https://itsfoss.com/best-gnome-extensions/&title=Top+20+GNOME+Extensions+You+Should+Be+Using+Right+Now
[9]:https://extensions.gnome.org/
[10]:https://www.gnome.org/
[11]:https://itsfoss.com/ubuntu-17-10-release-features/
[12]:https://itsfoss.com/ubuntu-unity-shutdown/
[13]:https://itsfoss.com/gnome-shell-extensions/
[14]:https://www.kde.org/
[15]:https://elementary.io/
[16]:https://itsfoss.com/gnome-3-26-released/
[17]:https://extensions.gnome.org/extension/1217/appfolders-manager/
[18]:https://en.wikipedia.org/wiki/APT_(Debian)
[19]:https://extensions.gnome.org/extension/1139/apt-update-indicator/
[20]:https://extensions.gnome.org/extension/16/auto-move-windows/
[21]:https://extensions.gnome.org/extension/517/caffeine/
[22]:https://extensions.gnome.org/extension/945/cpu-power-manager/
[23]:https://extensions.gnome.org/extension/779/clipboard-indicator/
[24]:https://extensions.gnome.org/extension/1036/extensions/
[25]:https://extensions.gnome.org/extension/2/move-clock/
[26]:https://extensions.gnome.org/extension/608/gnomenu/
[27]:https://youtu.be/9TNvaqtVKLk
[28]:https://itsfoss.com/install-themes-ubuntu/
[29]:https://extensions.gnome.org/extension/19/user-themes/
[30]:https://extensions.gnome.org/extension/744/hide-activities-button/
[31]:https://community.kde.org/KDEConnect
[32]:https://www.kde.org/plasma-desktop
[33]:https://extensions.gnome.org/extension/1272/mconnect/
[34]:http://openweathermap.org/
[35]:https://darksky.net/forecast/40.7127,-74.0059/us12/en
[36]:https://extensions.gnome.org/extension/750/openweather/
[37]:https://extensions.gnome.org/extension/708/panel-osd/
[38]:https://extensions.gnome.org/extension/8/places-status-indicator/
[39]:https://extensions.gnome.org/extension/905/refresh-wifi-connections/
[40]:https://numixproject.github.io/
[41]:https://extensions.gnome.org/extension/800/remove-dropdown-arrows/
[42]:https://extensions.gnome.org/extension/355/status-area-horizontal-spacing/
[43]:https://extensions.gnome.org/extension/234/steal-my-focus/
[44]:https://extensions.gnome.org/extension/427/workspaces-to-dock/
[45]:https://extensions.gnome.org/extension/307/dash-to-dock/
[46]:https://extensions.gnome.org/extension/1160/dash-to-panel/
