 
 translating by HardworkFish

 [![Linux vs. Unix](http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/unix-vs-linux_orig.jpg)][1] 

​In computer time, a substantial part of the population has a misconception that the **Unix** and **Linux** operating systems are one and the same. However, the opposite is true. Let's look at it from a closer look.

### What is Unix?

 [![what is unix](http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/unix_orig.png)][2] 

In IT, we come across

[Unix][3]

as an operating system (under the trademark), which was created by AT & T in 1969 in New Jersey, USA. Most operating systems are inspired by Unix, but Unix has also been inspired by the Multics system, which has not been completed. Another version of Unix was Plan 9 from Bell Labs.

### Where is Unix used?

As an operating system, Unix is used in particular for servers, workstations, and nowadays also for personal computers. It played a very important role in the creation of the Internet, the creation of computer networks or also the client-server model. 

#### Characteristics of the Unix system:

*   supports multitasking (multitasking)

*   Simplicity of control compared to Multics

*   all data is stored as plain text

*   tree saving of a single-root file

*   access to multiple user accounts​

#### Unix Operating System Composition:

​

**a)**

a monolithic operating system kernel that takes care of low-level and user-initiated operations, the total communication takes place via a system call.

**b)**

system utilities (or so-called utilities)

**c)**

many other applications

### What is Linux?

 [![what is linux](http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/linux_orig.png)][4] 

This is an open source operating system built on the principle of a Unix system. As the name of the open-source description suggests, it is a freely-downloadable system that can be downloaded externally, but it is also possible to interfere with the system's editing, adding, and then extending the source code. It's one of the biggest benefits, unlike today's operating systems that are paid (Windows, Mac OS X, ...). Not only was Unix a model for creating a new operating system, another important factor was the MINIX system. Unlike

**Linus**

, this version was used by its creator (

**Andrew Tanenbaum**

) as a commercial system.

​

[Linux][5]

began to be developed by

**Linus Torvalds**

in 1991, which was a system that dealt with as a hobby. One of the main reasons why Linux started to deal with Unix was the simplicity of the system. The first official release of the provisory version of Linux (0.01) occurred on September 17, 1991\. Even though the system was completely imperfect and complete, it was of great interest to him, and within a few days, Linus started to write emails with other ideas about expansion or source codes.

### Characteristics of Linux

The cornerstone of Linux is the Unix kernel, which is based on the basic characteristics of Unix and the standards that are

**POSIX**

 and  Single

**UNIX Specification**

. As it may seem, the official name of the operating system is taken from the creator of

**Linus**

, where the end of the operating system name "x" is just a link to the

**Unix system**

.

#### Main features:

*   run multiple tasks at once (multitasking)

*   programs may consist of one or more processes (multipurpose system), and each process may have one or more threads

*   multiuser, so it can run multiple user programs

*   individual accounts are protected by appropriate authorization

*   so the accounts have precisely defined system control rights

The author of

**Tuxe Penguin's**

logo is   Larry Ewing of 1996, who accepted him as a mascot for his open-source

**Linux operating system**

.

**Linux  Torvalds**

proposed the initial name of the new operating system as  "Freax" as free + freak + x (

**Unix system**

), but it did not like the

**FTP server**

where the provisory version of Linux was running.

--------------------------------------------------------------------------------

via: http://www.linuxandubuntu.com/home/linux-vs-unix

作者：[linuxandubuntu][a]
译者：[译者ID](https://github.com/译者ID)
校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:http://www.linuxandubuntu.com
[1]:http://www.linuxandubuntu.com/home/linux-vs-unix
[2]:http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/unix_orig.png
[3]:http://www.unix.org/what_is_unix.html
[4]:http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/linux_orig.png
[5]:https://www.linux.com
