手把手教你构建开放式文化
======
我们于 2015 年发表 `开放组织 (Open Organization)` 后，很对各种类型不同大小的公司都对“开放式”文化究竟意味着什么感到好奇。甚至当我跟别的公司谈论我们产品和服务的优势时，也总是很快就从谈论技术转移到人和文化上去了。几乎所有对推动创新和保持行业竞争优势有兴趣的人都在思考这个问题。

不是只有高级领导团队 (Senior leadership teams) 才对开放式工作感兴趣。[红帽公司最近一次调查 ][1] 发现 [81% 的受访者 ][2] 同意这样一种说法："拥有开放式的组织文化对我们公司非常重要。"

然而要注意的是。同时只有 [67% 的受访者 ][3] 认为："我们的组织有足够的资源来构建开放式文化。"

这个结果与我从其他公司那交流所听到的相吻合：人们希望在开放式文化中工作，他们只是不知道该怎么做。对此我表示同情，因为组织的行事风格是很难捕捉，评估，和理解的。在 [Catalyst-In-Chief][4] 中，我将其称之为 "组织中最神秘莫测的部分。"

开放式组织之所以让人神往是因为在这个数字化转型有望改变传统工作方式的时代，拥抱开放文化是保持持续创新的最可靠的途径。当我们在书写本文的时候，我们所关注的是描述在红帽公司中兴起的那种文化--而不是编写一本如何操作的书。我们并不会制定出一步步的流程来让其他组织采用。

这也是为什么与其他领导者和高管谈论他们是如何开始构建开放式文化的会那么有趣。在创建开发组织时，很多高管会说我们要"改变我们的文化"。但是文化并不是一项输入。它是一项输出--它是人们互动和日常行为的副产品。

告诉组织成员"更加透明地工作"，"更多地合作"，以及 "更加包容地行动" 并没有什么作用。因为像 "透明，" "合作，" and "包容" 这一类的文化特质并不是行动。他们只是组织内指导行为的价值观而已。

纳入要如何才能构建开放式文化呢？

在过去的两年里，Opensource.com 设计收集了各种以开放的精神来进行工作，管理和领导的最佳实践方法。现在我们在新书 [The Open Organization Workbook][5] 中将之分享出来，这是一本更加规范的引发文化变革的指引。

要记住，任何改变，尤其是巨大的改变，都需要许诺 (commitment)，耐心，以及努力的工作。我推荐你在通往伟大成功的大道上先使用这本工作手册来实现一些微小的，有意义的成果。

通过阅读这本书，你将能够构建一个开放而又富有创新的文化氛围，使你们的人能够茁壮成长。我已經迫不及待想听听你的故事了。

本文摘自 [Open Organization Workbook project][6]。

--------------------------------------------------------------------------------

via: https://opensource.com/open-organization/17/12/whitehurst-workbook-introduction

作者：[Jim Whitehurst][a]
译者：[lujun9972](https://github.com/lujun9972)
校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/jwhitehurst
[1]:https://www.redhat.com/en/blog/red-hat-releases-2017-open-source-culture-survey-results
[2]:https://www.techvalidate.com/tvid/923-06D-74C
[3]:https://www.techvalidate.com/tvid/D30-09E-B52
[4]:https://opensource.com/open-organization/resources/catalyst-in-chief
[5]:https://opensource.com/open-organization/resources/workbook
[6]:https://opensource.com/open-organization/17/8/workbook-project-announcement
