什么是容器？为什么我们关注它？
======
什么是容器？你需要它们吗？为什么？在这篇文章中，我们会回答这些基本问题。

但是，为了回答这些问题，我们要提出更多的问题。当你开始考虑怎么用容器适配你的工作时，你需要弄清楚：你在哪开发应用？你在哪测试它？你在哪使用它？

你可能在你的笔记本电脑上开发应用，你的电脑上已经装好了所需要的库文件，扩展包，开发工具，和开发框架。它在一个模拟生产环境的机器上进行测试，然后被用于生产。问题是这三种环境不一定都是一样的；他们没有同样的工具，框架，和库。你在你机器上开发的应用不一定可以在生产环境中正常工作。

容器解决了这个问题。正如 Docker 解释的，“容器镜像是软件的一个轻量的，独立的，可执行的包，包括了执行它所需要的所有东西：代码，运行环境，系统工具，系统库，设置。”

这代表着，一旦一个应用被封装成容器，那么它所依赖的下层环境就不再重要了。它可以在任何地方运行，甚至在混合云环境下也可以。这是容器在开发者，执行团队，甚至 CIO （信息主管）中变得如此流行的原因之一。

### 容器对开发者的好处

现在开发者或执行者不再需要关注他们要使用什么平台来运行应用。开发者不会再说：“这在我的系统上运行得好好的。”

容器的另一个重大优势时它的隔离性和安全性。因为容器将应用和运行平台隔离开了，应用以及它周边的东西都会变得安全。同时，不同的团队可以在一台设备上同时运行不同的应用——对于传统应用来说这是不可以的。

这不是虚拟机（ VM ）所提供的吗？是的，也不是。虚拟机可以隔离应用，但它负载太高了。[在一份文献中][1]，Canonical 比较了容器和虚拟机，结果是：“容器提供了一种新的虚拟化方法，它有着和传统虚拟机几乎相同的资源隔离水平。但容器的负载更小，它占用更少的内存，更为高效。这意味着可以实现高密度的虚拟化：一旦安装，你可以在相同的硬件上运行更多应用。”另外，虚拟机启动前需要更多的准备，而容器只需几秒就能运行，可以瞬间启动。

### 容器对应用生态的好处

现在，一个庞大的，由供应商和解决方案组成的生态系统已经允许公司大规模地运用容器，不管是用于编排，监控，记录，或者生命周期管理。

为了保证容器可以运行在任何地方，容器生态系统一起成立了[开源容器倡议][2]（OCI）。这是一个 Linux 基金会的项目，目标在于创建关于容器运行环境和容器镜像格式这两个容器核心部分的规范。这两个规范确保容器空间中不会有任何碎片。

在很长的一段时间里，容器是专门用于 Linux 内核的，但微软和 Docker 的密切合作将容器带到了微软平台上。现在你可以在 Linux，Windows，Azure，AWS，Google 计算引擎，Rackspace，以及大型计算机上使用容器。甚至 VMware 也正在发展容器，它的 [vSphere Integrated Container][3]（VIC）允许 IT 专业人员在他们平台的传统工作负载上运行容器。

### 容器对 CIO 的好处

容器在开发者中因为以上的原因而变得十分流行，同时他们也给CIO提供了很大的便利。将工作负载迁移到容器中的优势正在改变着公司运行的模式。

传统的应用有大约十年的生命周期。新版本的发布需要多年的努力，因为应用是独立于平台的，有时需要经过几年的努力才能看到生产效果。由于这个生命周期，开发者会尽可能在应用里塞满各种功能，这会使应用变得庞大笨拙，漏洞百出。

这个过程影响了公司内部的创新文化。当人们几个月甚至几年都不能看到他们的创意被实现时，他们就不再有动力了。

容器解决了这个问题。因为你可以将应用切分成更小的微服务。你可以在几周或几天内开发，测试和部署。新特性可以添加成为新的容器。他们可以在测试结束后以最快的速度被投入生产。公司可以更快转型，超过他们的竞争者。因为想法可以被很快转化为容器并部署，这个方式使得创意爆炸式增长。

### 结论

容器解决了许多传统工作负载所面对的问题。但是，它并不能解决所有 IT 专业人员面对的问题。它只是众多解决方案中的一个。在下一篇文章中，我们将会覆盖一些容器的基本属于，然后我们会解释如何开始构建容器。

通过 Linux 基金会和 edX 提供的免费的 ["Introduction to Linux" ][4] 课程学习更多 Linux 知识。

--------------------------------------------------------------------------------

via: https://www.linux.com/blog/intro-to-Linux/2017/12/what-are-containers-and-why-should-you-care

作者：[wapnil Bhartiya][a]
译者：[lonaparte](https://github.com/lonaparte)
校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://www.linux.com/users/arnieswap
[1]:https://www.ubuntu.com/containers
[2]:https://www.opencontainers.org/
[3]:https://www.vmware.com/products/vsphere/integrated-containers.html
[4]:https://training.linuxfoundation.org/linux-courses/system-administration-training/introduction-to-linux
