在 2018 年最值得去学习的编程语言
======

![](http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/best-programming-languages-learn-for-2018_orig.jpg)

编程现在已经变成最受欢迎的职业之一，不像以前，编制软件只局限于少数几种**编程语言**。现在，我们有很多种编程语言可以选择。随着跨平台支持需求的增多，大多数编程语言都可以被用于多种任务。如果，你还没有准备好，让我们看一下在 2018 年你可能会学习的编程语言有哪些。

## 在 2018 年最值得去学习的编程语言

### Python

 [![learn programming language](http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/learn-programming-language_orig.png)][1] 

毫无疑问， [Python][2] 现在已经统治着（ruling）编程的市场份额。它发起于 1991 年，自从 [YouTube][3] 开始使用它之后，python 已经真正的成为最著名的编程语言。Python 可以被用于各类领域，比如，Web 开发、游戏开发、脚本、科学研究、以及大多数你能想到的领域。它是跨平台的，并且运行在一个解释程序中。Python 的语法非常简单，因为它使用缩进代替花括号来对代码块进行分组，因此，代码非常清晰。

**示例 -**

```
printf("Hello world!")
```

### Kotlin

 [![kotlin programming language](http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/kotlin-programming-language_orig.jpg)][4] 

虽然 Java 自它诞生以来从没有被超越过，但是，至少在 Android 编程方面，Kotlin 在正打破这种局面。Kotlin 是较新的一个编程语言，它被 Google 官方支持用于Android 应用编程。它是 Java 的替代者，并且可以与 [java][5] 代码无缝衔接。代码大幅减少并且更加清晰。因此，在 2018 年，Kotlin 将是最值的去学习的编程语言。

**示例 -**

```
class Greeter(val name: String) {

  fun greet() {

     println("Hello, $name")

  }

}

String Interpolation to cut down ceremony.

fun main(args: Array) {

  Greeter(args[0]).greet()

}
```

### C/C++

这可能是他们在中学和大学里教的第一个编程语言。C 是比较老的编程语言之一，由于它的代码运行速度快而且简单，它到现在仍然一直被使用。虽然它的学习难度比较大，但是，一旦你掌握了它，你就可以做任何语言能做的事情。你可能不会用它去做高级的网站或者软件，但是，C 是嵌入式设备的首选编程语言。随着物联网的普及，C 将被再次广泛的使用，对于 C++，它被广泛用于一些大型软件。

**示例 -**

```
#include

Int main()

{

   printf("Hello world");

   return 0;

}
```

### PHP

 [![php programming language](http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/1200px-php-logo-svg_orig.png)][6] 

关于 PHP 即将消亡的话题，因特网上正在疯传，但是，我没有看到一个为什么不去学习 PHP 的理由，它是服务器端脚本语言中比较优秀的一个，它的语法结构非常简单。一半以上的因特网都运行在 PHP 上。[Wordpress][7]，这个最流行的内容管理系统是用 PHP 写的。因为，这个语言流行的时间已经超过 20 年了，它已经有了足够多的库。在这些库中，你总能找到一个是适合你的工作的。

**示例 -**

```
echo "Hello world!";
```

### Javascript

 ![javascript programming language for web](http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/javascript_orig.png) 

关于 Javascript，我说些什么呢？这是目前最为需要的语言。Javascript 主要用于网站动态生成页面。但是，现在 JavaScript 已经演进到可以做更多的事情。全部的后端框架都是用 JavaScript 构建的。Hybrid 应用是用 HTML+JS 写的，它被用于构建任何移动端的平台。使用 Javascript 的 nodejs 甚至被用于服务器端的脚本。

**示例 -**

```
document.write("Hello world!");
```

### SQL

 [![sql database language](http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/published/sql-database-language.png?1514386856)][8] 

SQL 是一个关系型数据库管理系统（RDBMS）的查询语言，它用于从数据库中获取数据。SQL 的主要实现或多或少都是非常相似的。数据库用途非常广泛。你读的这篇文章它就保存在我们网站的数据库中。因此，学会它是非常有用的。

**示例 -**

```
SELECT * FROM TABLENAME
```

## 结论

因为这些语言都是在 2018 年比较值得去学习的。我并没有包括像 asp.net 这样的 **语言**，因为，它要求你学习它们的整个平台。Java 也没有推荐，因为有大量的开发者已经开始迁到 Kotlin。所有提到的语言的市场需求都非常大，并且它们都很流行。它们也都有非常好的社区支持。我希望你喜欢这篇文章。如果你认为我遗漏了任何一个非常受人欢迎的语言，请在下面的评论区告诉我。

--------------------------------------------------------------------------------

via: http://www.linuxandubuntu.com/home/best-programming-languages-to-learn-in-2018

作者：[LinuxAndUbuntu][a]
译者：[qhwdw](https://github.com/qhwdw)
校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:http://www.linuxandubuntu.com
[1]:http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/learn-programming-language_orig.png
[2]:http://www.linuxandubuntu.com/home/best-python-ides-for-linux
[3]:http://www.linuxandubuntu.com/home/youtube-dl-a-command-line-gui-youtube-facebook-dailymotion-videos-downloading-tool-for-linux
[4]:http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/kotlin-programming-language_orig.jpg
[5]:http://www.linuxandubuntu.com/home/how-to-install-oracle-java-78-on-ubuntu
[6]:http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/1200px-php-logo-svg_orig.png
[7]:http://www.linuxandubuntu.com/home/wordpress-how-to-host-and-manage-on-web-server-in-linuxubuntu-step-by-step-guide
[8]:http://www.linuxandubuntu.com/uploads/2/1/1/5/21152474/sql-database-language_orig.png


